# Locate ICU include paths and libraries
# Written by Alexander Tsvyashchenko for DictD++ package

# This module defines
# ICU_INCLUDE_DIR, ICU_LIBRARY_DIR, ICU_FOUND.

SET(ICU_DIR_MESSAGE "Set the environment variable ICUROOT, or ICU_INCLUDE_DIR & ICU_LIBRARY_DIR cmake cache entries")

FIND_PATH(ICU_INCLUDE_DIR unicode/ustring.h
  $ENV{ICUROOT}/include/
  /usr/local/include
  /usr/include
)

FIND_PATH(ICU_LIBRARY_DIR icuuc
  $ENV{ICUROOT}/lib/
  /usr/local/lib
  /usr/lib
)

# if the include a the library are found then we have it
IF(ICU_INCLUDE_DIR)
  IF(ICU_LIBRARY_DIR)
    SET( ICU_FOUND "YES" )
  ENDIF(ICU_LIBRARY_DIR)
ENDIF(ICU_INCLUDE_DIR)


IF(NOT ICU_FOUND)
  IF(NOT ICU_FIND_QUIETLY)
    MESSAGE(STATUS "ICU was not found. ${ICU_DIR_MESSAGE}")
  ELSE(NOT ICU_FIND_QUIETLY)
    IF(ICU_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR "ICU was not found. ${ICU_DIR_MESSAGE}")
    ENDIF(ICU_FIND_REQUIRED)
  ENDIF(NOT ICU_FIND_QUIETLY)
ENDIF(NOT ICU_FOUND)
