# Locate Xerces-C include paths and libraries
# Xerces-C can be found at http://xml.apache.org/xerces-c/
# Written by Frederic Heem, frederic.heem _at_ telsey.it
# Modified by Alexander Tsvyashchenko for DictD++ package

# This module defines
# XERCESC_INCLUDE_DIR, XERCESC_LIBRARIES, XERCESC_FOUND.

SET(XERCESC_DIR_MESSAGE "Set the environment variable XERCESCROOT, or XERCESC_INCLUDE_DIR & XERCESC_LIBRARIES cmake cache entries")

FIND_PATH(XERCESC_INCLUDE_DIR xercesc/dom/DOM.hpp
  "[HKEY_CURRENT_USER\\software\\xerces-c\\src]"
  "[HKEY_CURRENT_USER\\xerces-c\\src]"
  $ENV{XERCESCROOT}/src/
  /usr/local/include
  /usr/include
)

FIND_LIBRARY(XERCESC_LIBRARIES
  NAMES 
    xerces-c
  PATHS
    "[HKEY_CURRENT_USER\\software\\xerces-c\\lib]"
    "[HKEY_CURRENT_USER\\xerces-c\\lib]"
    $ENV{XERCESCROOT}/lib
    /usr/local/lib
    /usr/lib
)

# if the include a the library are found then we have it
IF(XERCESC_INCLUDE_DIR)
  IF(XERCESC_LIBRARIES)
    SET( XERCESC_FOUND "YES" )
  ENDIF(XERCESC_LIBRARIES)
ENDIF(XERCESC_INCLUDE_DIR)


IF(NOT XERCESC_FOUND)
  IF(NOT XERCESC_FIND_QUIETLY)
    MESSAGE(STATUS "XercesC was not found. ${XERCESC_DIR_MESSAGE}")
  ELSE(NOT XERCESC_FIND_QUIETLY)
    IF(XERCESC_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR "XercesC was not found. ${XERCESC_DIR_MESSAGE}")
    ENDIF(XERCESC_FIND_REQUIRED)
  ENDIF(NOT XERCESC_FIND_QUIETLY)
ENDIF(NOT XERCESC_FOUND)

