/*****************************************************************************
 *
 * DictD++, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef ABSTRACT_MEMORY_MAPPER_H
#define ABSTRACT_MEMORY_MAPPER_H

//------------------------------------------------------------------------------
// This is an exception class used to report errors
// for IO.
class IOException: public GeneralException
  {
  public:
    IOException(const std::string& i_err_id,
		const std::string& i_msg):
      GeneralException("I/O", i_err_id, i_msg) {}
  };
//------------------------------------------------------------------------------
class AbstractMemoryMapper
  {
  public:
    virtual ~AbstractMemoryMapper() throw(IOException) {}

    virtual std::string GetName() const throw() = 0;
    virtual const char* Get() const throw() = 0;
    virtual storage_type Length() const throw() = 0;
  };
//------------------------------------------------------------------------------

#endif // ABSTRACT_MEMORY_MAPPER_H

