/*****************************************************************************
 *
 * DictD++, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef ACCESS_RIGHTS_H
#define ACCESS_RIGHTS_H

//--------------------------------------------------------------------
struct AccessRightsItem
  {
  enum ItemType
    {
    USER_NAME,
    GROUP_NAME
    }
  m_type;

  std::string m_name;
  bool m_fl_allowed;

  AccessRightsItem(ItemType i_type, const std::string& i_name, bool i_fl_allowed):
    m_type(i_type), m_name(i_name), m_fl_allowed(i_fl_allowed) {}
  };
//--------------------------------------------------------------------
struct AccessRights
  {
  typedef std::list<AccessRightsItem> AccessList;

  bool m_fl_default_access_policy;
  AccessList m_access_list;

  AccessRights(): m_fl_default_access_policy(true) {}
  };
//--------------------------------------------------------------------

#endif // ACCESS_RIGHTS_H

