/*****************************************************************************
 *
 * DictD++, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef CONVERTION_H
#define CONVERTION_H

#include "abstract_transformer.h"
//------------------------------------------------------------------------------
/// This class is responsible for keeping
/// convertion that can apply the sequence
/// of transforms
//------------------------------------------------------------------------------
class Convertion
  {
  public:
    Convertion(const std::map<UnicodeString, const AbstractTransformer*>& i_transformers);

    std::string GetInputMimeType() const throw(TransformerException);

    std::string GetOutputMimeType() const throw(TransformerException);

    UnicodeString Apply(const UnicodeString& i_input) const throw(TransformerException);
  
    void AddTransformStep(const UnicodeString& i_transformer_name, const UnicodeString& i_transform);

    void Validate() const throw(TransformerException);

  private:
    typedef std::list<std::pair<UnicodeString, UnicodeString> > TransformSteps;
    const std::map<UnicodeString, const AbstractTransformer*>& m_transformers;
    TransformSteps m_transform_steps;
  };
//------------------------------------------------------------------------------
#endif // CONVERTION_H
