/*****************************************************************************
 *
 * DictD++, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#include "stdafx.h"
#include "exact_match_strategy.h"
#include "index_utils.h"
#include "abstract_controller.h"

//------------------------------------------------------------------------------
ExactMatchStrategy::~ExactMatchStrategy() throw()
 {
 }
//------------------------------------------------------------------------------
UnicodeString ExactMatchStrategy::GetStrategyName() const throw()
  {
  return "exact";
  }
//------------------------------------------------------------------------------
UnicodeString ExactMatchStrategy::GetStrategyDescription() const throw()
  {
  return "Match words exactly";
  }
//------------------------------------------------------------------------------
void ExactMatchStrategy::FindKeyWords(std::list<index_type>& o_keywords, AbstractController& io_controller,
                                      const AbstractIndex& i_index, const UnicodeString& i_word) const throw(StrategyException)
  {
  UErrorCode status = U_ZERO_ERROR;
  CollationKey key;

  i_index.GetCollator() -> getCollationKey(i_word, key, status);

  if (U_FAILURE(status))
    throw StrategyException("CollationKeyCreationFailed", "Failed to create the collation key in exact matching strategy");

  std::pair<IndexIterator, IndexIterator> range =
    std::equal_range(IndexIterator(0), IndexIterator(i_index.GetNumberOfKeyWords()), key, IndexItemsComparator(&i_index));

  for (IndexIterator it = range.first; it != range.second; ++it)
    {
    if (!io_controller.IsMatchAllowed())
      break;
    io_controller.OneMoreMatch();

    o_keywords.push_back(*it);
    }
  }
//------------------------------------------------------------------------------
