/*****************************************************************************
 *
 * DictD++, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef MEMORY_MAPPED_FILE_H
#define MEMORY_MAPPED_FILE_H

#include "abstract_memory_mapper.h"
//------------------------------------------------------------------------------
// This is the class used to access files in memory-mapped mode.
//
class MemoryMappedFile: public AbstractMemoryMapper
  {
  public:
    MemoryMappedFile(const std::string& i_file_name) throw(IOException);

    ~MemoryMappedFile() throw(IOException);

    std::string GetName() const throw();
    const char* Get() const throw();
    storage_type Length() const throw();

  private:
    char* mp_buffer;
    std::string m_file_name;
    index_type m_length;
#ifdef _WIN32
    HANDLE mh_file, mh_map_file;
#else
  int mh_file;
#endif
  };
//------------------------------------------------------------------------------
inline
std::string MemoryMappedFile::GetName() const throw()
  {
  return m_file_name;
  }
//------------------------------------------------------------------------------
inline
const char* MemoryMappedFile::Get() const throw()
  {
  return mp_buffer;
  }
//------------------------------------------------------------------------------
inline
storage_type MemoryMappedFile::Length() const throw()
  {
  return m_length;
  }
//------------------------------------------------------------------------------

#endif // MEMORY_MAPPED_FILE_H
