/*****************************************************************************
 *
 * DictD++, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef PLAIN_POSITION_H
#define PLAIN_POSITION_H

#include "abstract_position.h"
//------------------------------------------------------------------------------
class PlainPosition: public AbstractPosition
  {
  public:
    storage_type m_pos, m_length;

  public:
    PlainPosition(): m_pos(0), m_length(0) {}

    PlainPosition(storage_type i_pos, storage_type i_length):
      m_pos(i_pos), m_length(i_length) {}

    virtual ~PlainPosition() {}

    std::string GetAsText() const;
  };
//------------------------------------------------------------------------------
inline std::string PlainPosition::GetAsText() const
  {
  std::ostringstream ostr;
  ostr << m_pos << ":" << m_length;
  return ostr.str();
  }
//------------------------------------------------------------------------------

#endif // PLAIN_POSITION_H
