/*****************************************************************************
 *
 * DictD++, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef PLAIN_STORAGE_H
#define PLAIN_STORAGE_H

#include "abstract_storage.h"

//------------------------------------------------------------------------------
class AbstractMemoryMapper;
class AbstractPosition;
//------------------------------------------------------------------------------
class PlainStorage: public AbstractStorage
  {
  public:
    PlainStorage(const std::string& i_codepage, const std::string& i_mime_type,
		 const AbstractMemoryMapper* ip_storage) throw(StorageException);

    virtual ~PlainStorage() throw();

    virtual std::string GetMimeType() const throw();

    virtual UnicodeString Get(const AbstractPosition& i_position) const throw(StorageException);

  private:
    std::string m_codepage, m_mime_type;
    const AbstractMemoryMapper* mp_storage;
    UConverter* mp_converter;
  };
//------------------------------------------------------------------------------
inline
std::string PlainStorage::GetMimeType() const throw()
  {
  return m_mime_type;
  }
//------------------------------------------------------------------------------

#endif // PLAIN_STORAGE_H
