/*****************************************************************************
 *
 * DictD++, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef SESSION_INFO_H
#define SESSION_INFO_H

#include "mime_type.h"
//------------------------------------------------------------------------------
/// This class is used to store the information
/// about current session settings, such as
/// MIME status and access rights
//
class SessionInfo
  {
  public:
    bool m_fl_use_mime;               ///< Did client request MIME?
    std::list<MimeType> m_mime_types; ///< MIME types that are accepted by the client
    std::string m_user,               ///< User name, "unknown" by default
                m_group;              ///< User group, "unknown" by default

    SessionInfo(): m_fl_use_mime(false),
                   m_user("unknown"), m_group("unknown")
      {
      m_mime_types.push_back(MimeType("*/*"));
      }
  };
//------------------------------------------------------------------------------
#endif // SESSION_INFO_H

