/*****************************************************************************
 *
 * DictD++, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#include "stdafx.h"
#include "wrapper_strategy.h"
#include "index_utils.h"

//------------------------------------------------------------------------------
WrapperStrategy::WrapperStrategy(const UnicodeString& i_name,
				 const UnicodeString& i_descr,
				 const AbstractStrategy* ip_strategy):
    m_name(i_name), m_descr(i_descr), mp_strategy(ip_strategy)
  {
  }
//------------------------------------------------------------------------------
WrapperStrategy::~WrapperStrategy() throw()
  {
  delete mp_strategy;
  }
//------------------------------------------------------------------------------
UnicodeString WrapperStrategy::GetStrategyName() const throw()
  {
  return m_name;
  }
//------------------------------------------------------------------------------
UnicodeString WrapperStrategy::GetStrategyDescription() const throw()
  {
  return m_descr;
  }
//------------------------------------------------------------------------------
void WrapperStrategy::FindKeyWords(std::list<index_type>& o_keywords, AbstractController& io_controller,
                                   const AbstractIndex& i_index, const UnicodeString& i_word) const throw(StrategyException)
  {
  return mp_strategy -> FindKeyWords(o_keywords, io_controller, i_index, i_word);
  }
//------------------------------------------------------------------------------
