/*****************************************************************************
 *
 * DictD++, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef CONTROLLER_H
#define CONTROLLER_H

#include "abstract_controller.h"

//------------------------------------------------------------------------------
class ControlThread;
//------------------------------------------------------------------------------
struct QueryControlOptions
  {
  time_t m_max_match_time, m_max_define_time;
  index_type m_max_match_entries, m_max_define_entries;

  QueryControlOptions();
  };
//------------------------------------------------------------------------------
class Controller: public AbstractController
  {
  public:
    QueryControlOptions m_options;

    Controller(const ControlThread* ip_ctrl_thread): mp_ctrl_thread(ip_ctrl_thread) {}

    virtual void OneMoreMatch();

    virtual void OneMoreDefine();

    virtual bool IsMatchAllowed();

    virtual bool IsDefineAllowed();

    virtual void StartMatch();

    virtual void StartDefine();

    virtual bool WasMatchInterrupted();

    virtual bool WasDefineInterrupted();

  private:
    const ControlThread* mp_ctrl_thread;
    index_type m_cur_match_entries, m_cur_define_entries;
    time_t m_cur_max_match_time, m_cur_max_define_time;
    bool m_fl_match_interrupted, m_fl_define_interrupted;
  };
//------------------------------------------------------------------------------

#endif // CONTROLLER_H
