/*****************************************************************************
 *
 * DictD++, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#include "stdafx.h"
#include "server.h"
#include <unicode/uclean.h>
#include <unicode/regex.h>

#include <xercesc/util/PlatformUtils.hpp>

#ifdef DICTDPP_USE_XALAN
  #include <xalanc/XalanTransformer/XalanTransformer.hpp>
#endif

//------------------------------------------------------------------------------
extern std::string g_config_path;
extern std::string g_log_path;
//------------------------------------------------------------------------------
void Initialize()
  {
  UErrorCode status = U_ZERO_ERROR;
  u_init(&status);

  if (U_FAILURE(status))
    {
    g_log << CRIT << "Failed to initialize ICU: " << u_errorName(status) << ", terminating ..." << endlog;
    throw;
    }

#ifdef _WIN32  
  WORD wVersionRequested;
  WSADATA wsaData;
  int err;
 
  wVersionRequested = MAKEWORD(1, 0);
 
  err = WSAStartup(wVersionRequested, &wsaData);
  if (err != 0)
    {
    g_log << CRIT << "Failed to initialize WinSock" << endlog;
    throw;
    }
#endif

  // Initialize the XML4C system
  try
    {
    xercesc::XMLPlatformUtils::Initialize();
    }
  catch (const xercesc::XMLException& ex)
    {
    g_log << CRIT << "Failed to initialize Xercesc, error message follows:" << endlog;
    g_log << CRIT << AsString(ex.getMessage()) << endlog;
    throw;
    }

#ifdef DICTDPP_USE_XALAN
  xalanc::XalanTransformer::initialize();
#endif
  }
//------------------------------------------------------------------------------
void DeInitialize()
  {
#ifdef DICTDPP_USE_XALAN
  xalanc::XalanTransformer::terminate();
#endif
  xercesc::XMLPlatformUtils::Terminate();
  u_cleanup();
  }
//------------------------------------------------------------------------------
