/*****************************************************************************
 *
 * DictD++, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef SERVER_THREAD_H
#define SERVER_THREAD_H

#include "socket.h"

#include <session_info.h>
#include <unicode/ucnv.h>

//--------------------------------------------------------------------
class Server;
//--------------------------------------------------------------------
class ServerThread
  {
  public:
    ServerThread(const Socket& i_sock, Server& i_server);

    void operator() ();

    ~ServerThread();

  private:
    Socket m_socket;
    Server& m_server;
    UConverter* mp_converter;
    SessionInfo m_session_info;
    std::string m_msg_id;

    struct CommandInfo
      {
      char* m_name;
      void (ServerThread::*m_function)(const std::vector<std::string>& i_list);
      };
    
    static CommandInfo mg_commands[];

    static const char *mg_info113, *mg_info230, *mg_info250, *mg_err500, *mg_err501,
		      *mg_err502, *mg_err530, *mg_err531, *mg_err550, *mg_err551,*mg_err552, *mg_err554;
    
    void DoDialog();
    
    void ProcessCommand(std::vector<std::string>& i_list);

    void CommDefine(const std::vector<std::string>& i_list);
    void CommMatch(const std::vector<std::string>& i_list);
    void CommShow(const std::vector<std::string>& i_list);
    void CommClient(const std::vector<std::string>& i_list);
    void CommStatus(const std::vector<std::string>& i_list);
    void CommHelp(const std::vector<std::string>& i_list);
    void CommQuit(const std::vector<std::string>& i_list);
    void CommOption(const std::vector<std::string>& i_list);
    void CommAuth(const std::vector<std::string>& i_list);
    void CommSaslAuth(const std::vector<std::string>& i_list);
  };
//--------------------------------------------------------------------
struct ServerThreadWrapper
  {
  ServerThread* mp_thread;

  ServerThreadWrapper(ServerThread* ip_thread): mp_thread(ip_thread) {}

  void operator() () { return mp_thread -> operator ()(); }
  };
//--------------------------------------------------------------------
#endif // SERVER_THREAD_H

